try(renamerTool.run())catch()
struct renamerTool
(
	instUI=undefined,
	currentSelectionAR=#(),
------------/*UPDATES MLB TO SHOW SELECTIONS*/--------------
	fn updaterFN=
	(
		currentSelectionAR=#()
		tempAR=#()
			for x in selection do
			(
				append currentSelectionAR x
				append tempAR x.name
			)
		instUI.selectionSR.selectionsR.selectionsMLB.items=tempAr
	),
	
------------/*REPLACES ORIGINAL NAME*/--------------
	fn replaceOrigNameFN objs findStr replaceStr=
	(
		for o in objs do
		(
			index= findString o.name findStr
			if index!=undefined do
			(
				o.name= replace o.name index findStr.count replaceStr
			)
		)
	),
		
------------/*SELECT NODE BY CLASS AND UPDATE MLB*/--------------
		fn classSelectFN className =
	(  
		case className of
		(
			#bones: (select(for o in objects where ClassOf o==boneGeometry collect o ))
			#helpers: (select helpers)
			#GeometryClass: (select(for o in objects where SuperClassOf o==GeometryClass collect o))
			#shapes: (select shapes)
			#cameras: (select cameras)
			#lights: (select lights)
			#NONE: (print "ok")
		)
		updaterFN()
	),
	
------------/*BUILD NEW NAME AND UPDATE MLB*/--------------
	fn previewDisplay prefix suffix side axis custom=
	(
		reName=#()
		for obj in currentSelectionAR do
		(
			newName=""
			currName= obj.name
		if prefix!="---NONE---" do
			( 
				newName+=prefix
			)
				newName+=currName
		if suffix!="---NONE---" do
			(
				newName+=suffix
			)
		if side!="---NONE---" do
			(
				newName+=side
			)
		if axis!="---NONE---" do
			(
				newName+=axis
			)
		if custom!="" do
			(
				newName+=custom
			)
			append reName newName
		)
		instUI.selectionSR.selectionsR.selectionsMLB.items= reName
	),

------------/*COMMIT TO THE NODE'S NEW NAME*/--------------
	fn reNameIt=
	(
		reName=instUI.selectionSR.selectionsR.selectionsMLB.items
		if currentSelectionAR.count==reName.count then
		(
			for t=1 to currentSelectionAR.count do
			(
				for c = 1 to currentSelectionAR.count do
				(
					currentSelectionAR[c].name=reName[c]
				)
			)
		)
	),
	
------------/*COMMIT TO USING SAVED INI AS NEW NAME*/--------------
	fn SreNameIt=
	(
		SreName=instUI.selectionSR.savedR.savedMLB.selection
		if currentSelectionAR.count==SreName.count then
		(
			for s=1 to currentSelectionAR.count do
			(
				for d = 1 to currentSelectionAR.count do
				(
					currentSelectionAR[d].name=SreName[d]
				)
			)
		)
	),
		
	-----------------------/*USEABLE ROLLOUT FNS*/------------------------
------------/*BUILD NEW NAME ROLLOUT*/--------------
	fn changesFN=
	(
		rollout changesR "Changes" width:300
		(
			dropDownList prefixDDL "Name:" Width:80  across:2 \
				items:#("---NONE---", "Bob_", "Knight_", "Gwen_", "Feel_", "free_", "to_", "add_", "more_")
			dropdownList sufDDL "TYPE:" Width:80 \
				items:#("---NONE---", "_CNT", "_BN", "_HLP", "_PNT", "_GEO")
			dropDownList sideDDL "Part:" Width:80 align:#left across:2 \
				items:#("---NONE---", "_Root", "_Main", "_Head", "_Hair", "_Eyebrow", "_Eyes", "_Spine", "_Pouch", "_Strap", "_Quiver", "_Bow", "_Bag", "_Armour", "_Leg", "_Knee", "_Arm", "_BlendArm", "_FKArm", "_IKArm", "_TwistArm",  "_Elbow", "_Neck", "_Shoulder", "_Clavicle", "_Hand", "_Finger", "_FingerThumb", "_FingerIndex", "_FingerMiddle", "_FingerRing", "_FingerPinky", "_Pants", "_Foot")
			dropDownList axisDDL "Side:" Width:80 align:#left across:2 \
				items:#("---NONE---", "_R_", "_C_", "_L_", "_F_", "_B_", "_T_", "_O_", "_M_")
			editText customET "Custom:" fieldWidth:100 align:#left labelOnTop:true
			
			fn callPreviewDisplayFN=
			(
				renamerTool.previewDisplay prefixDDL.items[prefixDDL.selection] sufDDL.items[sufDDL.selection] \
				sideDDL.items[sideDDL.selection] axisDDL.items[axisDDL.selection] customET.text
			)
			
			on prefixDDL selected index do
			(
				callPreviewDisplayFN()
			)
			on sufDDL selected index do
			(
				callPreviewDisplayFN()
			)
			on sideDDL selected index do
			(
				callPreviewDisplayFN()
			)
			on axisDDL selected index do
			(
				callPreviewDisplayFN()
			)	
			on customET entered arg do
			(
				callPreviewDisplayFN()
			)
		)
	),
	
------------/*REPLACE PARTS OF NAME*/--------------
	fn replaceNameFN=
	(
		rollout replaceNameR "Replace Parts of Name" 
		(
			editText findET "Find:"
			editText replaceET "Use:"
			button replaceGoBT "Go"
			
			on replaceGoBT pressed do
			(
				renamerTool.replaceOrigNameFN renamerTool.currentSelectionAR findET.text replaceET.text
				renamerTool.updaterFN()				
			)
		)
	),
	
------------/*SELECTION MLB ROLLOUT*/--------------
	fn selectionsFN=
	(
		ClassName=#()
		rollout selectionsR "Selections" width:150 
		(
			listBox selectionsMLB "Selections:"
			button updateMultiBT "Update" across:2 align:#left
			button renameSelectedBt "Rename Selected"
			
			on renameSelectedBT pressed do with undo on
			(
				renamerTool.reNameIt()
					if renamerTool.reNameIt==undefined then
				(
					renamerTool.selectObjClassFN()
				)
			)
			
			on updateMultiBT pressed do
			(
				renamerTool.updaterFN()
			)
		)
	),
	
------------/*REMOVE ALL NUMBERS IN NAME*/--------------
	fn removeNumbsFN=
	(
		rollout removeNumbsR "Remove Numbers"
		(
			button removeNumbsBT "Remove All"
			on removeNumbsBT pressed do
			(
				activeString= renamerTool.instUI.selectionSR.selectionsR.selectionsMLB.items
				newNumbAR=#()
				for x=1 to activestring.count do
				(
					fstring= filterstring activestring[x] "1234567890"
					newstring=""
					for x in fstring do
					(
						newstring+=x
					)
					append newNumbAR newstring
					print newNumbAR
				)
				renamerTool.instUI.selectionSR.selectionsR.selectionsMLB.items= newNumbAR
			)
		)
	),
	
------------/*SAVE INI FILE OF NAMES*/--------------
	fn savedFN=
	(
		rollout savedR "Saved Custom Presets" rolledUp:true
		(
			local iniPath=(getDir #plugCFG)+"\\CASrenamerTool.ini"
			
			listBox savedMLB "Saved Names:"
			button useSavedBT "Use Saved" across:2 width:70
			button reloadSavedBT "Reload List" width:70
			
			groupBox saveGB "Enter Custom Name"  height:80 width:(savedR.width-10)
			editText enterET width:130 pos:[30,220] 
			button saveToIniBT "Save" pos:[120, 245]
			
			fn getIniFN=
			(
				presetNamesAr=#()
				if doesFileExist iniPath do
				(
					presetNamesAr= getIniSetting iniPath "Presets" 
				)
				presetNamesAr
			)

			fn removeIllegalFN enterET=
			(
				illegalChars="!#%~`@$^&*\|()_+-=/<>{}[]:;"
				for i=1 to enterET.count do
				(
					findString illegalChars enterET[i]
				)
			)
			
			fn setIniFN=
			(
				if enterET.text !="" do
				(
					removeIllegalFN enterET.text
					setIniSetting iniPath "Presets" enterET.text "0"
				)
			)
			
			fn savedUpdaterFN=
			(
				savedMLB.items=#()
				savedMLB.items=getIniFN()
			)
			
			on savedR open do
			(
				savedUpdaterFN()
			)
			
			on saveToIniBT pressed do
			(
				setIniFN()
				savedUpdaterFN()
			)
			
			on useSavedBT pressed do
			(				
				for x in selection do
				(
					print x
				)
			)
			
			on reloadSavedBT pressed do
			(
				getIniFN()
			)
		)
	),
	
------------/*SELECT BY OBJ CLASS*/--------------
	fn selectObjClassFN=
	(
		rollout selectObjClassR "Select by Object Class"
		(
			dropdownList searchDDL "Available:" width:(selectObjClassR.width-20) align:#center \
				items:#("---NONE---", "bones", "cameras", "GeometryClass", "helpers", "lights",  "shapes")
			on searchDDL selected arg do
			(
				renamerTool.classSelectFN (searchDDL.selected as name)
			)
		)
	),

	------------/*MAIN ROLLOUT UI*/--------------
	fn mainUI=
	(
		rollout mainR "Cassandra McWade Renaming Tool v2.3" width:430 height:375
		(
			subrollout changesSR "Changes" height:(mainR.height-20) across:2
			subrollout selectionSR "Selected Nodes" height:(mainR.height-10) width:200
		)
	),
	
------------/*TOOL LAUNCHER*/--------------
	fn run=
	(
		if instUI==undefined then
		(
			instUI=mainUI()
			createDialog instUI
			addSubRollout instUI.changesSR (changesFN())			
			addSubRollout instUI.changesSR (selectObjClassFN())
			addSubRollout instUI.changesSR (replaceNameFN())	
				
			addSubRollout instUI.selectionSR (selectionsFN())
			addSubRollout instUI.selectionSR (removeNumbsFN())
			--addSubRollout instUI.selectionSR (savedFN())
			)else
		(
			destroyDialog instUI
			instUI=undefined
		)
	)
)
renamerTool=renamerTool()
renamerTool.run()